#include "pg.h"
#include "types.h"
#include "tank.c"
#include "trig.h"

static unsigned seed1;    
static unsigned seed2; 

/* Button bit masks */ 
#define CTRL_SQUARE     0x8000 
#define CTRL_TRIANGLE   0x1000 
#define CTRL_CIRCLE     0x2000 
#define CTRL_CROSS      0x4000 
#define CTRL_UP         0x0010 
#define CTRL_DOWN       0x0040 
#define CTRL_LEFT       0x0080 
#define CTRL_RIGHT      0x0020 
#define CTRL_START      0x0008 
#define CTRL_SELECT     0x0001 
#define CTRL_LTRIGGER   0x0100 
#define CTRL_RTRIGGER   0x0200 

/* Returned control data */ 
typedef struct _ctrl_data 
{ 
	int frame; 
	int buttons; 
	unsigned char analog[4]; 
	int unused; 
} ctrl_data_t; 


#define RGB(r, g, b) ((r)|((g)<<5)|((b)<<10))

#define BACKGROUND_COLOR RGB(0, 0, 0)
#define CELL_COLOR RGB(0, 0x1f, 0)
#define TEXT_COLOR RGB(0xFF, 0xFF, 0xFF) //white
#define FRAME_COLOR RGB(0, 0, 0x1f)
#define TARGET_COLOR RGB(0xB8, 0x86, 0x0B) // B8860B
#define YELLOW_COLOR RGB(0xFF, 0xFF, 0x00)

#define RED_COLOR 5278 
#define GREEN_COLOR 0x2ba9
#define GROUND_COLOR 0x1371

int dx;
int dy;
int x;
int y;
int yarb;  //used in computing the random numbers.
int r = 0;
int theland[240];
int players[8][11];  //player data
float barrel[8][2];	//data in drawing the tank barrels. Not part of player because it's float.
float bullet[10][10]; 	//data on bullets
int ground [474][257];
int drawarray[2][474][257];  //work arrays for drawing to the screen.
float anglex = 0;
float angley = 0;
int aiming = 0; // used to see when a person is done getting ready.
int video = 0; // which video array is in use.
int actplr; //remaining active players.
int guiclear[2]; // used in keeping the status bar clear while bullets are flying.
int cfskip = 0; //frameskip while bullets are in the air.
int t = 0;
int t2 = 0;
int gotomenu = 0;
int liveammo; // set up active bullets amount
int maxplayers = 4; //number of players in the game
int terminator[6][10];
int round;
int cpudebug;
void initSeeds()  //Part of the random system, I think
{ 
   seed1 = sceKernelLibcTime((void *) 0); 
   seed2 = sceKernelLibcTime((void *) 0); 
} 

unsigned int myRand()  // It's random, man!
{ 
   seed1 = (seed1 + 46906481) ^ seed2; 
   seed2 = seed1 ^ ( ((seed2<<3) | (seed2 >> 29)) + 103995407); 
    
   return seed1 - seed2; 
}

int exit_callback(void) //Going away
{
	sceKernelExitGame();

	return 0;
}

int CallbackThread(void *arg) // must be a sleep thing
{
	int cbid;

	cbid = sceKernelCreateCallback("Exit Callback", exit_callback);
	sceKernelRegisterExitCallback(cbid);
	sceKernelSleepThreadCB();

	return 0;
}

int SetupCallbacks(void)
{
	int thid = 0;

	thid = sceKernelCreateThread("update_thread", CallbackThread, 0x11, 0xFA0, 0, 0);
	if(thid >= 0)
	{
		sceKernelStartThread(thid, 0, 0);
	}

	return thid;
}

void Random(int number)
	{ 
	yarb = (myRand() % number) + 1;
}

//---------------------------------------------------------------------------
void compute(int angle)
{
	anglex = cos( angle + 180) * 2;
	angley = sin( angle + 180) *2;
}

//---------------------------------------------------------------------------
void printDecimal(int x, int y, int color, int value)
{
	int i;
	int zero = 1;
	char digits[6];
	for (i = 5; i >= 0; i--) {
		digits[i] = '0' + (value%10);
		value /= 10;
	}
	i = 0;
	while (i < 5 && digits[i] == '0') digits[i++] = 0;
	for (i = 0; i < 6; i++) {
		if (digits[i]) {
			pgPutChar((x++)*8, y*8, color, BACKGROUND_COLOR, digits[i], 1, 1, 1);
		}
	}
}

//---------------------------------------------------------------------------
void drawdirt()
{
	// int ground [474][257];
	int xo, yo;
	for (xo = 0; xo < 474; xo++) {
		for (yo = 0; yo < 257; yo++){
				pdraw (xo + 3, yo + 11, ground[xo][yo]); 
		}
	}
}

//---------------------------------------------------------------------------
void fillCell(int x, int y, int color)
{
	unsigned short* vram = (unsigned short*) pgGetVramAddr(x * 16, y * 16);
	int xo, yo;
	for (xo = 0; xo < 16; xo++) {
		for (yo = 0; yo < 16; yo++) {
			vram[xo + yo * 512] = color;
		}
	}
}

//---------------------------------------------------------------------------
void dirtini()
 { //attempt at drawing a landscape
	int landmark = 136;
	int j = 0;	
	int i = 0;
	while( i < 474){
	Random(9);
	if (yarb == 1){
	 landmark = landmark -2;
	groundarray(i,landmark);
	}
	if (yarb == 2){
	 landmark = landmark -1;
	groundarray(i,landmark);

	}
	if (yarb == 3){
	groundarray(i,landmark);

	i++;
	landmark = landmark -1;
	groundarray(i,landmark);

	}
	if (yarb == 4){
	groundarray(i,landmark);

	}
	if (yarb == 5){
	groundarray(i,landmark);

	i++;
	landmark = landmark +1;
	groundarray(i,landmark);

	}
	if (yarb == 6){
	 landmark = landmark +1;
	groundarray(i,landmark);

	}
	if (yarb == 7){
	landmark = landmark +2;
	groundarray(i,landmark);

	}
	if (yarb == 8){
	for (j = 0; i < 10; j++) {
	 landmark = landmark +2;
	groundarray(i,landmark);
	i++;
	}
	}
	if (yarb == 9){
		for (j = 0; i < 10; j++) {
			landmark = landmark -2;
			groundarray(i,landmark);
			i++;
		}
	}


}
}

//------------------------------------------------------------------------------------------

groundarray(int index, int landmark)
{
int loopy;
ground[index][landmark] = 500;
for (loopy = 0; loopy < landmark; loopy++) ground[index][loopy] = 0; //land above is erased
for (loopy = landmark + 1; loopy < 258; loopy++) ground[index][loopy] = 500; //land below is filled
}


//-------------------------------------------------------------------------------------------

void plotCellImage(int x, int y, unsigned short* image, int color)
{
	unsigned short* vram = (unsigned short*) pgGetVramAddr(x ,y);
	int xo, yo;
	for (yo = 0; yo < 6; yo++) {
		for (xo = 0; xo < 11; xo++) {
			if (*image != 0x1f) {
				vram[xo + yo * 512] = *image;
			} else vram[xo + yo * 512] = color;
			image++;
		}
	}
}

// ----------------------------------------------------------------------------------------

void placetank (int play)
// set initial parameters for tanks


{
	int paydirt = 0;
	int counter = 0;
	int x;
     	while (paydirt == 0){
		counter ++;
		for (x = 1; x < 10; x++) if (ground[players[play][0]+ x ][counter + 5] == 500) paydirt = 1; // on the ground
	}
	players[play][1] = counter;
	
}


//----------------------------------------------------------------------------------

void drawtank (int play,  unsigned short* image)
// this draws the main tank body in the selected color
	{
	if (players[play][3] > 2000) return;
	int color;
	//if (play == 0) 
	color = (200 + (play * 10));
	// (play == 1) color = 210;
	if (play > 9) color = 0;
	if (play > 9) play = play - 10;
	// unsigned short* image = tankData;
	int xo, yo;
	int tx = players[play][0];
	int ty = players[play][1]; 
	for (yo = 0; yo < 6; yo++) {
		for (xo = 0; xo < 11; xo++) {
			if (*image == 0x1f) ground[xo + tx][yo + ty] = color;
			if ((*image == 0x4210) && (color != 0)) ground[xo + tx][yo + ty] = 0x4210;
			if ((*image == 0x4210) && (color == 0)) ground[xo + tx][yo + ty] = 0; 
 
			image++;
		}
	}


int barrelx1;
//barrel[play][0];
//float barrelx2 = players[play][0] + 5;
int barrely1;
//float barrely2 = players[play][1];

barrel[play][0] = players[play][0] + 5;
barrel[play][1] = players[play][1];


// this code erases the old barrel
for (y = 0; y < 6; y++) {
	barrel[play][0] = barrel[play][0] + (anglex / 2);
	barrel[play][1] = barrel[play][1] + (angley / 2);
	barrelx1 = barrel[play][0];
	barrely1 = barrel[play][1];
	ground[barrelx1][barrely1] = 0; // draw over old barrel
	}

// now to draw the new barrel
compute(players[play][5]);
barrel[play][0] = players[play][0] + 5;
barrel[play][1] = players[play][1];
for (y = 0; y < 6; y++) {
	barrel[play][0] = barrel[play][0] + (anglex / 2);
	barrel[play][1] = barrel[play][1] + (angley / 2);
	barrelx1 = barrel[play][0];
	barrely1 = barrel[play][1];
	ground[barrelx1][barrely1] = color; // draw barrel
	}
barrel[play][0] = barrel[play][0] + (anglex / 2);
barrel[play][0] = barrel[play][0] + (anglex / 2);
barrel[play][1] = barrel[play][1] + (angley / 2);
barrel[play][1] = barrel[play][1] + (angley / 2);
// did this twice due to a problem with the bullet hitting the barrel upon exit
// at 45 degree angles.
}


//-------------------------------------------------------------------------------


void gui()
{
	int xo;
	// pgFillvram(0);
	drawgui(0);
	drawborder();
	for (xo = 0; xo < maxplayers; xo++) drawtank(xo, tankData);
	//drawtank(1, tankData);
	drawdirt();
	videoupdate();
	// pgWaitVn(temp1);
}


//-------------------------------------------------------------------------------

void gui_update(int activeplayer)
{
	// pgFillvram(0);
	drawgui(activeplayer);
	drawborder();
	//drawdirt();
	drawtank(activeplayer, tankData);
	drawdirt();
	videoupdate();
	guiclear[video] = 0; 
	//pgFlipShowFrameV();
	//pgFlipDrawFrame();
	// pgWaitVn(temp1);
}
//--------------------------------------------------------------------------
void bgui()
{
int current = video;
if (current == 0) video = 1;
if (current == 1) video = 0;
int sourcecolor;
int destcolor;
int xo, yo;
if (guiclear[video] == 0) {
	guiclear[video] = 1;
	for (xo = 0; xo < 480; xo++) {
		for (yo = 0; yo < 7; yo++) {
			pdraw (xo, yo, 0); 
		}
	}
}

//int ground [474][257];
//int drawarray[2][474][257];
cfskip++;
if (cfskip = 1)
	{
	cfskip = 0;
	for (xo = 0; xo < 474; xo++) {
		for (yo = 0; yo < 257; yo++){
			sourcecolor = ground[xo][yo];
			destcolor = drawarray[video][xo][yo];
			if (sourcecolor != destcolor)
				{
				drawarray[video][xo][yo] = sourcecolor;
				pdraw(xo + 3, yo + 11, sourcecolor);
				} 
		}
	}
pgFlipDrawFrame();
pgFlipShowFrameV();
}
}


//-------------------------------------------------------------------------------
ckdead()
{
int x;
int xo;
int yo;

for (x = 0; x < maxplayers; x++)
	{
	if (players[x][3] < 1)
		{
		players[x][3] = 2147483647;
		xo = players[x][0];
		yo = players[x][1];
		explode(xo + 5, yo + 3, 26);
		actplr--;
		}
	}
}
//-------------------------------------------------------------------------------
firebullet()
{
int play = 0;
int color;

ctrl_data_t ctrl; // set up input variable
int c;
//for (c = 0; c < maxplayers; c++) bullet[c][5] = 999;

//  bullet[c][6] =angley;	
//}
//compute(players[c][5]);
//bullet[c][5] =anglex;
//bullet[c][6] =angley;
//}

int barrelx1;
int barrely1;
int barrelx11;
int barrely11;
int charge;
float grav2 = .05;

// change current in some of the players to reflect the original owner.
int owner = 0;
int current = 0;
while (liveammo)
	{
	//check to see if anyone died.
	ckdead();
	
	current = current + 1;
	if (current == maxplayers) current = 0;
	charge  = bullet[current][2];
	color = bullet[current][3] + 1;
	smoketrace(color);
	
	if (bullet[current][2] != 0){
	owner = bullet[current][3];
	barrelx1 = bullet[current][0];
	barrely1 = bullet[current][1];
	
	compute(players[owner][5]);
	bullet[current][0] = bullet[current][0] + (anglex / 250) * (players[current][4]);
	bullet[current][1] = bullet[current][1] + (angley / 250)  * (players[current][4]); 
	bullet[current][1] = bullet[current][1] + bullet[current][4]; // that "down to earth" feeling
	bullet[current][4] = bullet[current][4] + grav2; // increase the pull of gravity

	// wrap-around effect
	if (barrelx1 < 0) bullet[current][0] = bullet[current][0] + 475;
	if (barrelx1 > 475) bullet[current][0] = bullet[current][0] - 476;

	// put shield hit method here, I guess...
	// Collision detection stuff here.
	

	// ground detection diagnostic - testing purposes only

	//drawgui(0);	
	//printDecimal(42, 0, TEXT_COLOR, players[0][3]);
	
	 // check to see if I hit the bottom
	if (barrely1 > 255){
		impact(barrelx1, barrely1, charge);
		bullet[current][2] = 0;
		liveammo = liveammo - 1;
	}else{

	
	// check to see if ground was hit
		if ((ground[barrelx1][barrely1] > 199)&& in_w(barrelx1,barrely1))
		{
			impact(barrelx1, barrely1, charge);
			liveammo = liveammo - 1;
			// cpu player logging algorithm
			terminator[owner][2] = bullet[current][0];
			terminator[owner][3] = bullet[current][1];
			
			
			// if (bullet[current][3] == 1){
			//	t= bullet[current][0];
			//	t2= bullet[current][1];
			//	}
			bullet[current][2] = 0;
		}else{
			//draw only if within window
			if ((barrelx1 > -1) && in_w(barrelx1,barrely1)) {
				ground[barrelx1][barrely1] = color + 100;
				bgui();
			}else{
				//take up time
				pgWaitVn(1);
				videoupdate();
			}
		}
	}
	ckdead();
	}

	// a pause or menu function would be nice here
	sceCtrlReadBufferPositive(&ctrl, 1); 
	if (ctrl.buttons & CTRL_TRIANGLE) liveammo = 0;  // temporary cancel
	if (ctrl.buttons & CTRL_SELECT) {
	gotomenu = 1;
	return;
	}
}
}


//------------------------------------------------------------------------------
smoketrace (int current)
{
current = current + 100;
	// int ground [474][257];
	
	int xo, yo;
	for (xo = 0; xo < 474; xo++) {
		for (yo = 0; yo < 257; yo++){
				if (ground[xo][yo] == current) ground[xo][yo] = current - 100; 
		}
	}
}


//------------------------------------------------------------------------------

int in_w(int xo, int yo) // Check within window. Returns 1 if yes, 0 if no.
{
	if ((xo > -1) && (xo < 474) && (yo > -1) && (yo < 257)) {
		return 1;
	} else {
		return 0;
	}
}


//------------------------------------------------------------------------------
impact(int xo, int yo, int weapon)
{
int yield;
if (weapon == 1) yield = 5; 
if (weapon == 2) yield = 12; 
if (weapon == 3) yield = 26; 
explode(xo, yo, yield);
}

//------------------------------------------------------------------------------

explode(int xo, int yo, int yield)
{
float ex2;
float ey2;
int ex1;
int ey1;
int x;
int y;


// 12 = missile
// 5  = bably missile
// 26   = nuke

		
	for (x = 1; x < 361; x++){
		ex2 = xo;
		ey2 = yo;
		compute(x);
		for (y = 1; y < yield; y ++){
		ex2 = ex2 + (anglex / 2);
		ey2 = ey2 + (angley / 2);
		ex1 = ex2;
		ey1 = ey2;
		// let's check to see if we hit a tank!
		if (ground[ex1][ey1] == 200) players[0][3] = players[0][3] - 200;
		if (ground[ex1][ey1] == 210) players[1][3] = players[1][3] - 200;
		if (ground[ex1][ey1] == 220) players[2][3] = players[2][3] - 200;
		if (ground[ex1][ey1] == 230) players[3][3] = players[3][3] - 200;
		if (ground[ex1][ey1] == 240) players[4][3] = players[4][3] - 200;
		if (ground[ex1][ey1] == 250) players[5][3] = players[5][3] - 200;

		
		if (in_w (ex1, ey1)) ground[ex1][ey1] = RED_COLOR;
		
		}
	}
bgui();
//videoupdate();
pgWaitVn(8);
for (x = 1; x < 361; x++){
		ex2 = xo;
		ey2 = yo;
		compute(x);
		for (y = 1; y < yield; y ++){
		ex2 = ex2 + (anglex / 2);
		ey2 = ey2 + (angley / 2);
		ex1 = ex2;
		ey1 = ey2;
		if (in_w (ex1, ey1)) ground[ex1][ey1] = 0;
		
		}
	}
bgui();
}

//---------------------------------------------------------------------------------
int tankfall()


{
int fallen = 0;
int play = 0;
int paydirt = 0;
for (play = 0; play < maxplayers; play++){  // play <= maxplayers
	int counter = players[play][1] - 1;
	int x;
      while (paydirt == 0){
		counter ++;
		for (x = 1; x < 10; x++) if (ground[players[play][0]+ x ][counter + 5] == 500) paydirt = 1; // on the ground
		if (counter + 5 > 254) paydirt = 1;
		if (paydirt == 0) fallen = 1;
		drawtank(play + 10, tankData);
		players[play][1] = counter;
		drawtank(play, tankData);
		videoupdate(); //bgui();
		//pgWaitVn(5);
	}
}
return fallen; //retval;
}



// ----------------------------------------------------------------------------------------

int dirtfall()
{
int checker;
int ycheck;
int value1;
int falling = 1;
int fallen;
	
	int xo, yo;
	
int retval = 0;
while (falling)
{
fallen = 0;
	for (xo = 0; xo < 474; xo++) {
		for (yo = 256; yo > 0; yo--){
			if (ground[xo][yo] < 200){				
					value1 = ground[xo][yo - 1]; 
					if (value1 == 500) 
						{
						ground[xo][yo] = ground[xo][yo -1]; // ground value
						ground[xo][yo - 1] = 0; 
						fallen = 1;
						retval = 1;
						}
					
				}
		}
	}
bgui();
if (fallen == 0) falling = 0;
}
return retval;
}

//----------------------------------------------------------------------------------

void keyboardControl(int activeplayer)
{
int play = activeplayer;
int x;
int y;
int temp;
int mxpwr = players[play][3];


	ctrl_data_t ctrl;
	sceCtrlReadBufferPositive(&ctrl, 1); 

	// power without speedup
	if (ctrl.buttons & CTRL_DOWN && !(ctrl.buttons & CTRL_LTRIGGER))  {
	players[play][4] = players[play][4] - 1;
	if (players[play][4] < 0) players[play][4] = 0;
	gui_update(activeplayer);
	// pgWaitVn(1);  //this causes a delay
	}	

	if (ctrl.buttons & CTRL_UP && !(ctrl.buttons & CTRL_LTRIGGER))  {
	players[play][4] = players[play][4] + 1;
	if (players[play][4] > mxpwr) players[play][4] = mxpwr;
	gui_update(activeplayer);
	// pgWaitVn(1);  //this causes a delay
	}
	
	// power with speedup
	if (ctrl.buttons & CTRL_DOWN && (ctrl.buttons & CTRL_LTRIGGER))  {
	players[play][4] = players[play][4] - 10;
	if (players[play][4] < 0) players[play][4] = 0;
	gui_update(activeplayer);
	// pgWaitVn(1);  //this causes a delay
	}	

	if (ctrl.buttons & CTRL_UP && (ctrl.buttons & CTRL_LTRIGGER))  {
	players[play][4] = players[play][4] + 10;
	if (players[play][4] > mxpwr) players[play][4] = mxpwr;
	gui_update(activeplayer);
	// pgWaitVn(1);  //this causes a delay
	}

	

	// angle without speedup
	if (ctrl.buttons & CTRL_LEFT && !(ctrl.buttons & CTRL_LTRIGGER))  {
	players[play][5] = players[play][5] - 1;
	if (players[play][5] < 0) players[play][5] = 180;
	gui_update(activeplayer);
	// pgWaitVn(1);  //this causes a delay
	}	

	if (ctrl.buttons & CTRL_RIGHT && !(ctrl.buttons & CTRL_LTRIGGER))  {
	players[play][5] = players[play][5] + 1;
	if (players[play][5] > 180) players[play][5] = 0;
	gui_update(activeplayer);
	// pgWaitVn(1);  //this causes a delay
	}
	
	// angle with speedup
	if (ctrl.buttons & CTRL_LEFT && (ctrl.buttons & CTRL_LTRIGGER))  {
	players[play][5] = players[play][5] - 10;
	if (players[play][5] < 0) players[play][5] = 180;
	gui_update(activeplayer);
	// pgWaitVn(1);  //this causes a delay
	}	

	if (ctrl.buttons & CTRL_RIGHT && (ctrl.buttons & CTRL_LTRIGGER))  {
	players[play][5] = players[play][5] + 10;
	//if (players[play][5] > 180) players[play][5] = 0;
	gui_update(activeplayer);
	// pgWaitVn(1);  //this causes a delay
	}

	

	
if (ctrl.buttons & CTRL_CIRCLE) {
players[activeplayer][2] = players[activeplayer][2] + 1;
filter();
gui_update(activeplayer);
}

if (ctrl.buttons & CTRL_SQUARE) {
players[activeplayer][2] = players[activeplayer][2] - 1;
filter();
gui_update(activeplayer);
}
	
	
	if (ctrl.buttons & CTRL_CROSS) {
		
		bullet[activeplayer][3] = activeplayer;  // set owner
		bullet[activeplayer][0] =barrel[activeplayer][0];	// set x value
		bullet[activeplayer][1] =barrel[activeplayer][1];	// set y value
		bullet[activeplayer][4] = .005; //set gravity
		aiming = 0; //done with this turn
		bullet[activeplayer][2] = players[activeplayer][2]; // set bullet type
		liveammo++; // set up active bullets amount
		filter();

	}


	if (ctrl.buttons & CTRL_TRIANGLE) {
	int xo, yo;
	for (xo = 0; xo < 474; xo++) {
		for (yo = 0; yo < 257; yo++){
			if (ground[xo][yo] < 11) ground[xo][yo] = 0;
		}
	}
		gui();
		}




if (ctrl.buttons & CTRL_START)
{

// note: I already know where the tanks are: it's stored in
// the variables! I'm such a dummy...
int x = (t  - (players[0][0]));
int y = ((players[0][0]) - t);
int z;
int xx;
int yy;
int zz;

	printDecimal(5, 5, TEXT_COLOR, x);
	printDecimal(5, 6, TEXT_COLOR, y);	
	printDecimal(5, 7, TEXT_COLOR, t);	
	printDecimal(5, 8, TEXT_COLOR, t2);	
	printDecimal(6, 9, TEXT_COLOR, players[0][0]);	
	printDecimal(6, 10, TEXT_COLOR, players[0][1]);	
	printDecimal(8, 11, TEXT_COLOR, players[1][0]);	
	printDecimal(8, 12, TEXT_COLOR, players[1][1]);	
	//printDecimal(5, 13, TEXT_COLOR, (t  - (players[0][0]));	
	//printDecimal(5, 14, TEXT_COLOR, ((players[0][0]) - t);	
	//printDecimal(5, 15, TEXT_COLOR, players[active][3]);	
	//printDecimal(5, 16, TEXT_COLOR, players[active][3]);	
	//printDecimal(5, 17, TEXT_COLOR, players[active][3]);	
	//printDecimal(5, 18, TEXT_COLOR, players[active][3]);	
	pgFlipDrawFrame();
	pgFlipShowFrameV();
	pgWaitVn(500); 
	}

if (ctrl.buttons & CTRL_SELECT) gotomenu = 1;



}


filter()
{
ctrl_data_t ctrl;
sceCtrlReadBufferPositive(&ctrl, 1); 
while(ctrl.buttons != 0){
	sceCtrlReadBufferPositive(&ctrl, 1); 
	pgWaitVn(0);
	}

}



drawgui(int active)
{
// clear top area
int xo, yo;
	for (xo = 0; xo < 480; xo++) {
		for (yo = 0; yo < 7; yo++) {
			pdraw (xo, yo, 0); 
		}
	}
pgPrint(0, 0, TEXT_COLOR, "Power:");
printDecimal(7, 0, TEXT_COLOR, players[active][4] );    
pgPrint(13, 0, TEXT_COLOR, "Angle:");
printDecimal(20, 0, TEXT_COLOR, players[active][5]);    
//pgPrint(25, 0, TEXT_COLOR, "Romshark");
if (active == 0) pgPrint(25, 0, RED_COLOR, "RED TANK");
if (active == 1) pgPrint(25, 0, GREEN_COLOR, "GREEN TANK");
if (active == 2) pgPrint(25, 0, 0x6d51, "VIOLET TANK");
if (active == 3) pgPrint(25, 0, 0x3ff, "YELLOW TANK");

//0x6d51;
//0x3ff
// diagnostic use only
//printDecimal(40, 0, TEXT_COLOR, players[active][3]);


// 0 is for inactive shot. Do not use 0!
// sets min and max for weapons.
if (players[active][2] == 0 ) players[active][2] = 3;
if (players[active][2] == 4) players[active][2] = 1;


if (players[active][2] == 1 ) pgPrint(42, 0, TEXT_COLOR, "Baby Missile");
if (players[active][2] == 2 ) pgPrint(42, 0, TEXT_COLOR, "Missile     ");
if (players[active][2] == 3 ) pgPrint(42, 0, TEXT_COLOR, "Nuke        ");


//if (players[active][2] == 4 ) pgPrint(42, 0, TEXT_COLOR, "Death's Head");
//if (players[active][2] == 5 ) pgPrint(42, 0, TEXT_COLOR, "Baby Missile");
//if (players[active][2] == 6 ) pgPrint(42, 0, TEXT_COLOR, "Baby Missile");







}



drawborder(){
int x;
for (x = 0; x < 480; x++) pdraw (x, 8, YELLOW_COLOR); //top border
for (x = 2; x < 478; x++) pdraw (x, 10, YELLOW_COLOR);// top border
for (x = 0; x < 480; x++) pdraw (x, 271, YELLOW_COLOR); // bottom border
for (x = 2; x < 478; x++) pdraw (x, 269, YELLOW_COLOR); // bottom border
for (x = 8; x < 271; x++) pdraw (0, x, YELLOW_COLOR); // left border
for (x = 10; x < 269; x++) pdraw (2, x, YELLOW_COLOR); // left border
for (x = 8; x < 271; x++) pdraw (479, x, YELLOW_COLOR); // right border
for (x = 10; x < 269; x++) pdraw (477, x, YELLOW_COLOR); // right border

// So the drawable area for the field is from 3 to 478 on the x scale,
// and from 11 to 268 on the y scale.
// Must define array that is 475 x 257.
}


//------------------------------------------------------------------------------

videoupdate()
{
int current = video;
if (current == 0) video = 1;
if (current == 1) video = 0;
int sourcecolor;
int destcolor;

	// int ground [474][257];
	int xo, yo;
	for (xo = 0; xo < 474; xo++) {
		for (yo = 0; yo < 257; yo++){
			sourcecolor = ground[xo][yo];
			destcolor = drawarray[video][xo][yo];
			if (sourcecolor != destcolor)
				{
				drawarray[video][xo][yo] = sourcecolor;
				pdraw(xo + 3, yo + 11, sourcecolor);
				} 
		}
	}
pgFlipDrawFrame();
pgFlipShowFrameV();
}

//---------------------------------------------------------------------------------

pdraw (int x, int y, int pcolor)
{
int color = pcolor;
if (pcolor == 500) color = GROUND_COLOR;
if (pcolor == 1) color = RED_COLOR;
if (pcolor == 2) color = GREEN_COLOR;
if (pcolor == 3) color = 0x6d51;
if (pcolor == 4) color = 0x3ff;

if (pcolor == 50) color = 255;

if (pcolor == 200) color = RED_COLOR;
if (pcolor == 210) color = GREEN_COLOR;
if (pcolor == 220) color = 0x6d51;
if (pcolor == 230) color = 0x3ff;



if ((pcolor > 99) && (pcolor < 200)) color = 16777215;

//if (pcolor == 23) color = RED_COLOR;
unsigned short* vram = (unsigned short*) pgGetVramAddr(x,y);
vram[0] = color;
}

//---------------------------------------------------------------------------------
void CPUtank(int player)
{

int chosen = 1;
int target = terminator[player][1];
int xo = 0;
int humans = 0;
int softcode = terminator[player][0];
for (xo = 0; xo < maxplayers; xo++) if ((terminator[xo][0] == 0) && (players[xo][3]) < 1001)  humans++;
if (humans == 0) softcode = 1;

int newtarget = 0;
if (round == 1) newtarget = 1;
if (players[target][3] > 1000) newtarget = 1;

if (newtarget)
	{
	int choosing = 1;
	while (choosing)
		{
		Random(maxplayers);
		chosen = 1;
		yarb--;
		if (yarb == player) chosen = 0;
		if (players[yarb][3] > 1000) chosen = 0;
		if ((terminator[yarb][0] > 0) && (softcode == 2)) chosen = 0;
		if (chosen == 1) choosing = 0;
		//if (chosen2 == 1) choosing = 0;
		}	
terminator[player][1] = yarb;
target = yarb;
players[player][4] = 200;
}else{
//target = terminator[player][1];
}		


// direction of target
int facingright;
int tankx = players[player][0];
int targetx = players[target][0];
int distance = 0;
if (targetx > tankx){
		facingright = 1;
		players[player][5] = 130;
		//distance = targetx - tankx;
		}
if (targetx < tankx) {
		facingright = 0;
		players[player][5] = 50;
		//distance = targetx - tankx;
		}


int exright = 0;
int explosionx = terminator[player][2];
if (targetx > explosionx){
		exright = 0;
		//players[player][5] = 130;
		distance = targetx - explosionx;
		}
if (targetx < explosionx) {
		exright = 1;
		//players[player][5] = 50;
		distance = explosionx - targetx;
		}

if (newtarget == 0)
{
int changeamount = 0;
if (distance  < 8) changeamount = 3;
if (distance > 7 && distance < 50) changeamount = 17;
if (distance > 49 && distance < 100) changeamount = 40;
if (distance > 99) changeamount = 120;


if (exright == 1 && facingright == 1) players[player][4] = players[player][4] - changeamount;
if (exright == 1 && facingright == 0) players[player][4] = players[player][4] + changeamount;
if (exright == 0 && facingright == 1) players[player][4] = players[player][4] + changeamount;
if (exright == 0 && facingright == 0) players[player][4] = players[player][4] - changeamount;
}




		gui_update(player);
		bullet[player][3] = player;  // set owner
		bullet[player][0] =barrel[player][0];	// set x value
		bullet[player][1] =barrel[player][1];	// set y value
		bullet[player][4] = .005; //set gravity
		aiming = 0; //done with this turn
		bullet[player][2] = players[player][2]; // set bullet type
		liveammo++; // set up active bullets amount

if (cpudebug) // gui selection
{
gui_update(player);
pgPrint(5, 2, TEXT_COLOR, "TERMINATOR 101 BIOS (C) 2032");
pgPrint(5, 3, TEXT_COLOR, "Hardcode");
printDecimal(21, 3, TEXT_COLOR, terminator[player][0]);	
pgPrint(5, 4, TEXT_COLOR, "Softcode");
printDecimal(21, 4, TEXT_COLOR, softcode);	
pgPrint(5, 5, TEXT_COLOR, "Humans");
printDecimal(21, 5, TEXT_COLOR, humans);	
pgPrint(5, 6, TEXT_COLOR, "Current Tank ID");
printDecimal(21, 6, TEXT_COLOR, player);	
pgPrint(5, 7, TEXT_COLOR, "Target Tank ID");
printDecimal(21, 7, TEXT_COLOR, target);	
pgPrint(5, 8, TEXT_COLOR, "Target Health");
printDecimal(21, 8, TEXT_COLOR, players[target][3]);	
pgPrint(5, 9, TEXT_COLOR, "New Target");
printDecimal(21, 9, TEXT_COLOR, newtarget);	
pgPrint(5, 10, TEXT_COLOR, "Target to right");
printDecimal(21, 10, TEXT_COLOR, facingright);	
pgPrint(5, 11, TEXT_COLOR, "Target Distance");
printDecimal(21, 11, TEXT_COLOR, distance);	
pgPrint(5, 12, TEXT_COLOR, "Round");
printDecimal(21, 12, TEXT_COLOR, round);	
pgPrint(5, 13, TEXT_COLOR, "Explosion X");
printDecimal(21, 13, TEXT_COLOR, terminator[player][2]);	
pgPrint(5, 14, TEXT_COLOR, "Explosion to rt.");
printDecimal(21, 14, TEXT_COLOR, exright);
	pgFlipDrawFrame();
	pgFlipShowFrameV();

ctrl_data_t ctrl;
sceCtrlReadBufferPositive(&ctrl, 1); 
int cola = 1;
while(cola){
	sceCtrlReadBufferPositive(&ctrl, 1);
	 if (ctrl.buttons & CTRL_CROSS) cola = 0;
 	pgWaitVn(0);
	}

sceCtrlReadBufferPositive(&ctrl, 1); 
while(ctrl.buttons != 0){
	sceCtrlReadBufferPositive(&ctrl, 1); 
	pgWaitVn(0);
	}
gui_update(player);
gui_update(player);
}
}

//---------------------------------------------------------------------------------
tankini()
{
	int ct;
	int xo;
	int xmen[10];
	for (xo = 0; xo < 10; xo++)xmen[xo] = 0; // clear all to 0
	for (xo = 0; xo < maxplayers; xo++) 
		{
		ct = 1;
		while (ct)
			{
			Random(9);
			if (xmen[yarb] == 0){
			xmen[yarb] = 1;
			players[xo][0] = 5 + (yarb * 50);
			ct = 0;
			}
		//outside of if statement
		}
	//outside of while statement, but still in the for loop
	}
for (xo = 0; xo < maxplayers; xo++)
	{	
	placetank(xo); //get the tank on the ground
	players[xo][2] = 1; // set initial weapon selected
	players[xo][3] = 1000;	
	players[xo][4] = 200;
	players[xo][5] =45;
	}
}
//---------------------------------------------------------------------------------
void menu()
{
ctrl_data_t ctrl;
int cola = 1;
maxplayers = 0;
pgFillvram(0);
pgPrint(22, 1, TEXT_COLOR, "Scorched Earth");
pgPrint(21, 2, TEXT_COLOR, "Cheap Menu system");
pgPrint(5, 5, TEXT_COLOR, "CPU Tank Debug mode? O = yes X = no");
pgFlipDrawFrame();
pgFlipShowFrameV();
cola = 1;
while(cola){
	sceCtrlReadBufferPositive(&ctrl, 1);
	if (ctrl.buttons & CTRL_CROSS)
	{
		cpudebug = 0;
	 	cola = 0;
	}
	 if (ctrl.buttons & CTRL_CIRCLE)
	{
		cpudebug = 1;
 		cola = 0;
	}
}
int xo = 0;
int decide = 1;
int current = 0;
while (decide)
{
pgFillvram(0);
if (cpudebug) pgPrint(21, 2, TEXT_COLOR, "Debug mode on"); else pgPrint(21, 2, TEXT_COLOR, "Debug mode off");

pgPrint(2, 4, TEXT_COLOR, "X = human (0), Square = CPU type 1 (1), O = CPU type 2 (2)");
if (current > 2) {
	pgPrint(5, 5, TEXT_COLOR, "Triangle = Start game with only   players");
	printDecimal(37, 5, TEXT_COLOR, current);	
	}

for (xo = 0; xo < current - 1; xo++)
	{
	pgPrint(7, 7 + xo, TEXT_COLOR, "Tank");
	printDecimal(12, 7 + xo, TEXT_COLOR, xo + 1);
	printDecimal(15, 7 + xo, TEXT_COLOR, terminator[xo][0]);
}

pgPrint(5, 25, TEXT_COLOR, "Tank");
printDecimal(10, 25, TEXT_COLOR, current);

pgFlipDrawFrame();
pgFlipShowFrameV();

cola = 1;
while(cola){
	sceCtrlReadBufferPositive(&ctrl, 1);
	if (ctrl.buttons & CTRL_CROSS)
	{
		terminator[current-1][0] = 0;
		current++;
	 	cola = 0;
	}
	 if (ctrl.buttons & CTRL_CIRCLE)
	{
		terminator[current-1][0] = 2;
		current++;
	 	cola = 0;

	}
 if (ctrl.buttons & CTRL_SQUARE)
	{
		terminator[current-1][0] = 1;
		current++;
	 	cola = 0;

	}
 if ((ctrl.buttons & CTRL_TRIANGLE) && (current > 2))
	{
		decide = 0;
	 	cola = 0;
	}
}
sceCtrlReadBufferPositive(&ctrl, 1); 
while(ctrl.buttons != 0){
	sceCtrlReadBufferPositive(&ctrl, 1); 
	pgWaitVn(0);
	}
if (current > 4) decide = 0;
}
maxplayers = current-1;
}
//---------------------------------------------------------------------------------

int xmain(int ra)
{

int activeplayer;

	// These are the standard startup things
	pgInit();
	pgScreenFrame(1, 1);	
	SetupCallbacks();
	initSeeds();
	int xo, yo;
	

	// This is where stuff should be edited.
	pgFlipShowFrameV();  // Needed to get things in order. Not sure why...
	while (1)
	{	
	menu();

	//terminator[0][0] = 0;
	//terminator[1][0] = 2;
	//terminator[2][0] = 2;
	//terminator[3][0] = 1;



	ctrl_data_t ctrl;
	gotomenu = 0;
	while (gotomenu == 0) {   //use for infinite looping
	
	
	actplr = maxplayers;
		dirtini();

	drawborder();
	drawgui(0);
	drawdirt();
	tankini();
	round = 0;
	int liveammo = 0; // set up active bullets amount
	
	gui(); //draw screen and all tanks
		while (actplr > 1 && gotomenu == 0) // loop for current level
		{
		round++; // increment round in current level
		for (activeplayer = 0; activeplayer < maxplayers; activeplayer= activeplayer + 1){
		aiming = 1;
		gui_update(activeplayer);
		while (aiming)	{
			
			//don't let dead characters play.
			
			// temp code to test falling and stuff
			//players[0][3] = 1000;	
			//players[1][3] = 1000;
			//gui_update(activeplayer);

			if (players[activeplayer][3] > 2000) 
				{
				 
				aiming = 0; 
				} else { 
				gui_update(activeplayer);
				if (terminator[activeplayer][0] == 0)
					{
					keyboardControl(activeplayer); // get values for control
					if (gotomenu) aiming = 0;
				}else{
				CPUtank(activeplayer);
				}
			}
		}
		}
	
	if (gotomenu == 0)
	{
		firebullet();
		aiming = 1;
		while (aiming){
			xo = tankfall();
			yo = dirtfall();
			videoupdate();
			if ((xo == 0) && (yo == 0)) aiming = 0;	
		}
	}
	}
	//ready for next level	
	// clear top area
	for (xo = 0; xo < 480; xo++) {
		for (yo = 0; yo < 7; yo++) {
			pdraw (xo, yo, 0); 
		}
	}
	pgPrint(3, 0, TEXT_COLOR, "Press START button for next round. . .");
	videoupdate();
	//sceCtrlReadBufferPositive(&ctrl, 1); 
	aiming = 1;
	while (aiming){
		sceCtrlReadBufferPositive(&ctrl, 1); 
		if (ctrl.buttons & CTRL_START) aiming = 0;
		if (gotomenu) aiming = 0;
		pgWaitVn(20);
		}
	}
	}
	return 0;
}
